package org.jeecg.modules.stm.compliane.item.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.compliane.item.entity.StComplianePunish;
import org.jeecg.modules.stm.compliane.item.service.IStComplianePunishService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 合规处罚
 * @Author: yzh
 * @Date:   2023-03-31
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/compliane.item/stComplianePunish")
@Slf4j
public class StComplianePunishController extends JeecgController<StComplianePunish, IStComplianePunishService> {
	@Autowired
	private IStComplianePunishService stComplianePunishService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stComplianePunish
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "合规处罚-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StComplianePunish>> queryPageList(StComplianePunish stComplianePunish,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StComplianePunish> queryWrapper = QueryGenerator.initQueryWrapper(stComplianePunish, req.getParameterMap());
		Page<StComplianePunish> page = new Page<StComplianePunish>(pageNo, pageSize);
		IPage<StComplianePunish> pageList = stComplianePunishService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stComplianePunish
	 * @return
	 */
	@AutoLog(value = "合规处罚-添加")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StComplianePunish stComplianePunish) {
		stComplianePunishService.save(stComplianePunish);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stComplianePunish
	 * @return
	 */
	@AutoLog(value = "合规处罚-编辑")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StComplianePunish stComplianePunish) {
		stComplianePunishService.updateById(stComplianePunish);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "合规处罚-通过id删除")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stComplianePunishService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "合规处罚-批量删除")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stComplianePunishService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "合规处罚-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StComplianePunish> queryById(@RequestParam(name="id",required=true) String id) {
		StComplianePunish stComplianePunish = stComplianePunishService.getById(id);
		if(stComplianePunish==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stComplianePunish);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stComplianePunish
    */
    @RequiresPermissions("compliane.item:st_compliane_item:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StComplianePunish stComplianePunish) {
        return super.exportXls(request, stComplianePunish, StComplianePunish.class, "合规处罚");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("compliane.item:st_compliane_item:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StComplianePunish.class);
    }

}
